/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.35
        Device            :  PIC16F18325
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set S1 aliases
#define S1_TRIS               TRISAbits.TRISA2
#define S1_LAT                LATAbits.LATA2
#define S1_PORT               PORTAbits.RA2
#define S1_WPU                WPUAbits.WPUA2
#define S1_OD                ODCONAbits.ODCA2
#define S1_ANS                ANSELAbits.ANSA2
#define S1_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define S1_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define S1_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define S1_GetValue()           PORTAbits.RA2
#define S1_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define S1_SetPullup()      do { WPUAbits.WPUA2 = 1; } while(0)
#define S1_ResetPullup()    do { WPUAbits.WPUA2 = 0; } while(0)
#define S1_SetPushPull()    do { ODCONAbits.ODCA2 = 0; } while(0)
#define S1_SetOpenDrain()   do { ODCONAbits.ODCA2 = 1; } while(0)
#define S1_SetAnalogMode()  do { ANSELAbits.ANSA2 = 1; } while(0)
#define S1_SetDigitalMode() do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set LED aliases
#define LED_TRIS               TRISAbits.TRISA5
#define LED_LAT                LATAbits.LATA5
#define LED_PORT               PORTAbits.RA5
#define LED_WPU                WPUAbits.WPUA5
#define LED_OD                ODCONAbits.ODCA5
#define LED_ANS                ANSELAbits.ANSA5
#define LED_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define LED_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define LED_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define LED_GetValue()           PORTAbits.RA5
#define LED_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define LED_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define LED_SetPullup()      do { WPUAbits.WPUA5 = 1; } while(0)
#define LED_ResetPullup()    do { WPUAbits.WPUA5 = 0; } while(0)
#define LED_SetPushPull()    do { ODCONAbits.ODCA5 = 0; } while(0)
#define LED_SetOpenDrain()   do { ODCONAbits.ODCA5 = 1; } while(0)
#define LED_SetAnalogMode()  do { ANSELAbits.ANSA5 = 1; } while(0)
#define LED_SetDigitalMode() do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set SCK1 aliases
#define SCK1_TRIS               TRISCbits.TRISC0
#define SCK1_LAT                LATCbits.LATC0
#define SCK1_PORT               PORTCbits.RC0
#define SCK1_WPU                WPUCbits.WPUC0
#define SCK1_OD                ODCONCbits.ODCC0
#define SCK1_ANS                ANSELCbits.ANSC0
#define SCK1_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define SCK1_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define SCK1_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define SCK1_GetValue()           PORTCbits.RC0
#define SCK1_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define SCK1_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define SCK1_SetPullup()      do { WPUCbits.WPUC0 = 1; } while(0)
#define SCK1_ResetPullup()    do { WPUCbits.WPUC0 = 0; } while(0)
#define SCK1_SetPushPull()    do { ODCONCbits.ODCC0 = 0; } while(0)
#define SCK1_SetOpenDrain()   do { ODCONCbits.ODCC0 = 1; } while(0)
#define SCK1_SetAnalogMode()  do { ANSELCbits.ANSC0 = 1; } while(0)
#define SCK1_SetDigitalMode() do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set SDI1 aliases
#define SDI1_TRIS               TRISCbits.TRISC1
#define SDI1_LAT                LATCbits.LATC1
#define SDI1_PORT               PORTCbits.RC1
#define SDI1_WPU                WPUCbits.WPUC1
#define SDI1_OD                ODCONCbits.ODCC1
#define SDI1_ANS                ANSELCbits.ANSC1
#define SDI1_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define SDI1_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define SDI1_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define SDI1_GetValue()           PORTCbits.RC1
#define SDI1_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define SDI1_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define SDI1_SetPullup()      do { WPUCbits.WPUC1 = 1; } while(0)
#define SDI1_ResetPullup()    do { WPUCbits.WPUC1 = 0; } while(0)
#define SDI1_SetPushPull()    do { ODCONCbits.ODCC1 = 0; } while(0)
#define SDI1_SetOpenDrain()   do { ODCONCbits.ODCC1 = 1; } while(0)
#define SDI1_SetAnalogMode()  do { ANSELCbits.ANSC1 = 1; } while(0)
#define SDI1_SetDigitalMode() do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set RC2 procedures
#define RC2_SetHigh()    do { LATCbits.LATC2 = 1; } while(0)
#define RC2_SetLow()   do { LATCbits.LATC2 = 0; } while(0)
#define RC2_Toggle()   do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define RC2_GetValue()         PORTCbits.RC2
#define RC2_SetDigitalInput()   do { TRISCbits.TRISC2 = 1; } while(0)
#define RC2_SetDigitalOutput()  do { TRISCbits.TRISC2 = 0; } while(0)
#define RC2_SetPullup()     do { WPUCbits.WPUC2 = 1; } while(0)
#define RC2_ResetPullup()   do { WPUCbits.WPUC2 = 0; } while(0)
#define RC2_SetAnalogMode() do { ANSELCbits.ANSC2 = 1; } while(0)
#define RC2_SetDigitalMode()do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set IR aliases
#define IR_TRIS               TRISCbits.TRISC3
#define IR_LAT                LATCbits.LATC3
#define IR_PORT               PORTCbits.RC3
#define IR_WPU                WPUCbits.WPUC3
#define IR_OD                ODCONCbits.ODCC3
#define IR_ANS                ANSELCbits.ANSC3
#define IR_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define IR_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define IR_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define IR_GetValue()           PORTCbits.RC3
#define IR_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define IR_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define IR_SetPullup()      do { WPUCbits.WPUC3 = 1; } while(0)
#define IR_ResetPullup()    do { WPUCbits.WPUC3 = 0; } while(0)
#define IR_SetPushPull()    do { ODCONCbits.ODCC3 = 0; } while(0)
#define IR_SetOpenDrain()   do { ODCONCbits.ODCC3 = 1; } while(0)
#define IR_SetAnalogMode()  do { ANSELCbits.ANSC3 = 1; } while(0)
#define IR_SetDigitalMode() do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set RC4 procedures
#define RC4_SetHigh()    do { LATCbits.LATC4 = 1; } while(0)
#define RC4_SetLow()   do { LATCbits.LATC4 = 0; } while(0)
#define RC4_Toggle()   do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define RC4_GetValue()         PORTCbits.RC4
#define RC4_SetDigitalInput()   do { TRISCbits.TRISC4 = 1; } while(0)
#define RC4_SetDigitalOutput()  do { TRISCbits.TRISC4 = 0; } while(0)
#define RC4_SetPullup()     do { WPUCbits.WPUC4 = 1; } while(0)
#define RC4_ResetPullup()   do { WPUCbits.WPUC4 = 0; } while(0)
#define RC4_SetAnalogMode() do { ANSELCbits.ANSC4 = 1; } while(0)
#define RC4_SetDigitalMode()do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set SDO1 aliases
#define SDO1_TRIS               TRISCbits.TRISC5
#define SDO1_LAT                LATCbits.LATC5
#define SDO1_PORT               PORTCbits.RC5
#define SDO1_WPU                WPUCbits.WPUC5
#define SDO1_OD                ODCONCbits.ODCC5
#define SDO1_ANS                ANSELCbits.ANSC5
#define SDO1_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define SDO1_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define SDO1_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define SDO1_GetValue()           PORTCbits.RC5
#define SDO1_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define SDO1_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define SDO1_SetPullup()      do { WPUCbits.WPUC5 = 1; } while(0)
#define SDO1_ResetPullup()    do { WPUCbits.WPUC5 = 0; } while(0)
#define SDO1_SetPushPull()    do { ODCONCbits.ODCC5 = 0; } while(0)
#define SDO1_SetOpenDrain()   do { ODCONCbits.ODCC5 = 1; } while(0)
#define SDO1_SetAnalogMode()  do { ANSELCbits.ANSC5 = 1; } while(0)
#define SDO1_SetDigitalMode() do { ANSELCbits.ANSC5 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/